# Copyright (c) 2004-2009 Moxie Marlinspike
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA
#

import socket, logging
#from M2Crypto import SSL
from ShuffleSocket import ShuffleSocket

class SSLShuffleSocket(ShuffleSocket):

    ''' This is just a normal ShuffleSocket, slighly extended to have the underlying
    layer be SSL.  The python SSL stuff... isn't that good (surprise).

    '''

    _sslSocket = None

    def __init__(self, host, port=443):
#        ctx        = SSL.Context("sslv23")
#        self._socket = SSL.Connection(ctx, socket.socket(socket.AF_INET, socket.SOCK_STREAM))
#        self._socket.connect((host, port))
#        self.setupExpressions()
        ShuffleSocket.__init__(self, host=host, port=port)
        self._sslSocket = socket.ssl(self._socket)

    def getLogLevel(self):
        return logging.INFO

    def write(self, data):
        self._sslSocket.write(data)
        #self._socket.write(data)

    def _raw_read(self):
        return self._sslSocket.read()
        #return self._socket.read(1024)

    def close(self):
        del self._sslSocket
        self._socket.close()
